<!--  Table header  -->
@if ((genericError$ | async) === null) {
  <app-sr-table-header
    [count]="_tableData?.count"
    [dropdownData]="_columns"
    (columnSelectionChanged)="onColumnSelectionChanged($event)"
  ></app-sr-table-header>
  <!--  Assets Table  -->
  <div class="eui-table__scrollable-wrapper">
    <table
      euiTable
      [asyncTable]="config.asyncTable"
      [euiTableResponsive]="config.isResponsive"
      [isHoverable]="config.isHoverable"
      [rows]="_tableData?.list"
      (sortChange)="onSortChange($event)">
      <!--  Table header  -->
      <ng-template euiTemplate="header">
        <tr>
          @if (config.isExpandable) {
            <th class="eui-u-ph-none" aria-hidden="true"></th>
          }
          @for (col of _columns; track col) {
            @if (col.isVisible) {
              <th
                [sortDisabled]="!col.isSortable"
                [defaultOrder]="(config?.defaultSorting?.columns===col.id) ? true : null"
                [sortOrder]="config?.defaultSorting?.order"
                sortable
                sortOn="{{col.id}}">
                {{ col.columnLabel | translate }}
              </th>
            }
          }
        </tr>
      </ng-template>
      <!--  Table body  -->
      <ng-template let-row euiTemplate="body">
        <tr
          srHovering
          [ngClass]="{'sr-selected-row-bg-primary-5':row.opened}">
          <!--  Expand row icon  -->
          @if (config.isExpandable) {
            <td
              class="expandable-row__toggler"
              data-col-label="Click to expand">
              @if (row?.distributions?.length) {
                <button
                  euiButton
                  euiRounded
                  euiIconButton
                  euiSizeS
                  euiBasicButton
                  euiBranding
                  (click)="row.opened = !row.opened">
                  <eui-icon-svg icon="chevron-{{row.opened? 'down' :'forward'}}" set="outline" size="m"
                  fillColor="grey-100"></eui-icon-svg>
                </button>
              }
            </td>
          }
          <!--  Table Cells  -->
          @if (showColumns[ColumnIdEnum.ASSET_TYPE]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Asset Type">{{ row.type }}
            </td>
          }
          @if (showColumns[ColumnIdEnum.ASSET_NAME]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Asset Name">
              <a (click)="redirectToAssetDetails(row)" class="sr-link">{{ row.name }}</a>
            </td>
          }
          @if (showColumns[ColumnIdEnum.VERSION]) {
            <td data-col-label="Version">
              @if (row.version) {
                <eui-chip
                  euiSizeS
                  class="{{row?.isCurrentVersion ? 'sr-chip-grey-90' : 'sr-chip-outline-grey-90'}}">
                  <span euiLabel>{{ row.version }}</span>
                </eui-chip>
              }
            </td>
          }
          @if (showColumns[ColumnIdEnum.PUBLISHER]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Publisher">{{ row?.publisher }}
            </td>
          }
          @if (showColumns[ColumnIdEnum.MODIFIED]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Last Modified">{{ row.lastModified | date:'dd/MM/yyyy' }}
            </td>
          }
          @if (showColumns[ColumnIdEnum.STATUS]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Status">{{ row.status }}
            </td>
          }
          @if (showColumns[ColumnIdEnum.ISSUED]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Issued Modified">{{ row.issueDate | date:'dd/MM/yyyy' }}
            </td>
          }
          @if (showColumns[ColumnIdEnum.THEME]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Theme">
              @for (theme of row.themes; track theme) {
                <eui-chip
                  [euiOutline]="true"
                  euiTooltip="{{'app.features.sr.assetsList.table.chips.tooltip.theme.' + theme | translate}}"
                  position="above"
                  euiSizeS
                  euiBranding>{{ 'app.features.sr.assetsList.table.chips.label.theme.' + theme | translate }}
                </eui-chip>
              }
            </td>
          }
          @if (showColumns[ColumnIdEnum.TRANSACTION_COMPONENT]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Transaction component">
              @for (component of row.transactionComponents; track component) {
                <eui-chip
                  [euiOutline]="true"
                  euiTooltip="{{'app.features.sr.assetsList.table.chips.tooltip.transactionComponent.' + component | translate}}"
                  position="above" euiSizeS euiBranding>{{ component }}
                </eui-chip>
              }
            </td>
          }
          @if (showColumns[ColumnIdEnum.TRANSACTION_TYPE]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Transaction type">
              @for (type of row.transactionTypes; track type) {
                <eui-chip
                  [euiOutline]="true"
                  euiTooltip="{{'app.features.sr.assetsList.table.chips.tooltip.transactionType.' + type | translate}}"
                  position="above"
                  euiSizeS
                  euiBranding>{{ 'app.features.sr.assetsList.table.chips.label.transactionType.' + type | translate }}
                </eui-chip>
              }
            </td>
          }
          @if (showColumns[ColumnIdEnum.TRANSACTION_SUBJECT]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Transaction subject">
              @for (subject of row.transactionSubjects; track subject) {
                <eui-chip [euiOutline]="true"
                  euiTooltip="{{'app.features.sr.assetsList.table.chips.tooltip.transactionSubject.' + subject | translate}}"
                  position="above" euiSizeS
                  euiBranding>{{ 'app.features.sr.assetsList.table.chips.label.transactionSubject.' + subject | translate }}
                </eui-chip>
              }
            </td>
          }
          @if (showColumns[ColumnIdEnum.ASSET_REPOSITORY]) {
            <td [ngClass]="{'sr-selected-font-color-primary-100':row.opened}"
              data-col-label="Publisher">{{ row?.assetRepository }}
            </td>
          }
        </tr>
        <!--  Expand row content  -->
        @if (config.isExpandable) {
          @if (row.opened) {
            <tr class="sr-selected-row-bg-primary-5" euiTableExpandableRow>
              <td colspan="7" class="p-3 eui-u-pb-2xl eui-u-ph-2xl">
                <app-assets-distributions-table
                  [hasLargeSizeFontsTitle]="false"
                  [hasSorting]="false"
                  [distributionsData]="row?.distributions"
                  (distributionDownloadButtonClicked)="onDistributionDownloadButtonClicked($event)"
                  />
                </td>
              </tr>
            }
          }
        </ng-template>
        <ng-template euiTemplate="emptyMessage">
          @if ((isFirstRun$ | async) === false) {
            <tr>
              <td class="eui-u-p-none" [attr.colspan]="_columns?.length || 10 + 2">
                <span class="eui-u-flex eui-u-flex-column eui-u-p-m eui-u-bg-color-grey-5 eui-u-text-center eui-u-p-2xl">
                  <eui-icon-svg icon="trail-sign" size="l" set="outline" fillColor="grey-100"></eui-icon-svg>
                  <span
                  class="eui-u-pt-m eui-u-f-bold">{{ 'app.features.sr.assetsList.table.emptyState.title' | translate }}</span>
                  <span>{{ 'app.features.sr.assetsList.table.emptyState.subtitle' | translate }}</span>
                </span>
              </td>
            </tr>
          }
          @if ((isFirstRun$ | async)) {
            <tr>
              <td colspan="2">
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
            </tr>
            <tr>
              <td colspan="2">
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
            </tr>
            <tr>
              <td colspan="2">
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
              <td>
                <eui-skeleton line euiRounded></eui-skeleton>
              </td>
            </tr>
          }
        </ng-template>
      </table>
      <!--  Table paginator  -->
      <eui-paginator
        #paginator
        hasPageNumberNavigation
        [pageSizeOptions]="config?.pagination?.pageSizeOptions"
        [pageSize]="paginationOptions.pageSize"
        [length]="_tableData?.count"
        [page]="5"
        [isHidden]="_tableData?.count < config?.pagination?.visibilityLimit"
        (pageChange)="onPageChange($event)"
      ></eui-paginator>
    </div>
  } @else {
    <eui-alert euiDanger>
      <eui-alert-title>{{ errorTitle | translate }}</eui-alert-title>
      <span [innerHTML]="errorContent | translate"></span>
    </eui-alert>
  }

